質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.78%

IEでJSが動きません(外部ファイルを読み込み表示するタブ)

解決済

回答 2

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 1,736

minichika

score 13

JSで、外部ファイルを読み込んでコンテンツを表示する切り替えタブを制作しています。

参考サイトを元にいれこんだところ、IE11と古いipad(ios9.3.5)で動きませんでした。
古いipadは捨てるとして、なんとかIEで動くようにしたいと思います。

JSとIEの対策やajaxについて調べて試してみたもののうまくいかず、
原因となる箇所の目星もつけられず、少し焦っているのでこちらに質問させていただきました。

らんぼうな質問で申し訳ありませんが、対策がおわかりになる方いらっしゃいましたらお知恵を拝借できませんでしょうか。
よろしくお願いします。

【html】

<div id="tab_wrapper">
    <ul id="glossarytab">
      <li class="glossarytab-item" data-tab="tab1.html">タブ1</li>
      <li class="glossarytab-item" data-tab="tab2.html">タブ2</li>
      <li class="glossarytab-item" data-tab="tab3.html">タブ3</li>
      <li class="glossarytab-item" data-tab="tab4.html">タブ4</li>
    </ul>
</div>
<div id="glossaryContents">
<!-- コンテンツが読み込まれる場所-->
</div><!--glossaryContents-->


【js】
こちらのscript.jsをまるっと使用させていただきました
https://blanks.site/post/post50.html


$.ajax(contentsPath,{
type: 'get',
の次に、cache: false, を追加して
通信結果にキャッシュを残さないように対策してみましたが反応なし。

【その他】
読み込みコンテンツ用に、
tab1.html~tab4.htmlを用意

以上です。よろしくお願いします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • maisumakun

    2019/04/10 14:39

    開発用のサーバは、どのようなものを立てていますか?(Ajaxはローカルに対して呼ぶとブラウザによって挙動が違うので、ローカル開発でもサーバは必要です)

    キャンセル

  • minichika

    2019/04/10 14:48

    そうなのですね。申し訳ありません、開発サーバの詳細がわからないのですが、本番環境でも試していますが動きません。(さくらサーバ、webcrow)

    キャンセル

  • m.ts10806

    2019/04/10 14:54

    コードはマークダウンのcode機能を利用してご提示ください

    キャンセル

  • minichika

    2019/04/10 14:59

    失礼しました。編集いたしました。

    キャンセル

回答 2

checkベストアンサー

+1

カンマが余計なので取ってください。
これも IE での検証はしていないのでしょう。

//$('#'+tabContentsId+'-next').slideDown(),                                      //contents2をスライドダウンで表示
$('#'+tabContentsId+'-next').slideDown()

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/04/11 09:47

    カンマをとったところ、IEでも動きました‥!
    こんな単純なことでと驚くとともに、皆様に申し訳ない気持ちでいっぱいです‥。
    実はタイムリミットが近く、別のタブの実装をやりかけていましたが、こちらを使います。
    ほんとうにありがとうございました。

    キャンセル

+1

jQueryのバージョンを1.12でやっていますか?

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>


その他なにか特殊な処理をしているならエラー箇所のわかるような情報提示が必要です

追記

一応、非同期処理がからむのでpromiseのpolyfillを読んでおいてください

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<script src="https://www.promisejs.org/polyfills/promise-6.1.0.min.js"></script>

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/04/10 14:56

    ありがとうございます。
    バージョンは1.12.4でした。そうですね。どこがエラーになっているか、引き続き検証します。

    キャンセル

  • 2019/04/10 15:04

    一応polyfillの追記しました

    キャンセル

  • 2019/04/10 15:09

    ありがとうございます!入れてみました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.78%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る